using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using Exferia_General;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_TiposProductos_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MAE_TiposProductos_Listado_Modelo> g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposProductos).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo != null) && (g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposProductos).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo != null) && (g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                   " SELECT " +
                       nameof(INTERNO_MAE_TiposProductos_Listado_Modelo.id) + " = " + nameof(MAE_TiposProductos.id) + "," +
                       nameof(INTERNO_MAE_TiposProductos_Listado_Modelo.codigo) + " = " + nameof(MAE_TiposProductos.codigo) + "," +
                       nameof(INTERNO_MAE_TiposProductos_Listado_Modelo.descripcion) + " = " + nameof(MAE_TiposProductos.descripcion) +
               " FROM " + nameof(MAE_TiposProductos) +
               " WHERE " + nameof(MAE_TiposProductos.fechaBorrado) + " IS null AND " +
                       (_lng_id > -1 ? (nameof(MAE_TiposProductos.id) + "=@id") : "1 = 1");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_MAE_TiposProductos_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_TiposProductos_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3 
        private INTERNO_MAE_TiposProductos_Listado_Modelo g_mdl_INTERNO_MAE_TiposProductos_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposProductos).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_TiposProductos_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_TiposProductos_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposProductos).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_TiposProductos_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_TiposProductos_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                   " SELECT distinct " +
                       nameof(INTERNO_MAE_TiposProductos_Listado_Modelo.id) + " = " + nameof(MAE_TiposProductos.id) + "," +
                       nameof(INTERNO_MAE_TiposProductos_Listado_Modelo.codigo) + " = " + nameof(MAE_TiposProductos.codigo) + "," +
                       nameof(INTERNO_MAE_TiposProductos_Listado_Modelo.descripcion) + " = " + nameof(MAE_TiposProductos.descripcion) +
               " FROM " + nameof(MAE_TiposProductos) +
               " WHERE " + nameof(MAE_TiposProductos.fechaBorrado) + " IS null AND " +
                       (
                        (_lng_id > -1)
                          ? (nameof(MAE_TiposProductos.id) + " = " + _lng_id)
                          : (
                                //Filtrar por Codigo
                                (_str_CampoBusqueda.Equals(nameof(MAE_TiposProductos.codigo)))
                                    ? (nameof(MAE_TiposProductos.codigo) + "=@Filtro")
                                    //Filtrar por Descripcion
                                    : (nameof(MAE_TiposProductos.descripcion) + "=@Filtro")
                            )
                       );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_MAE_TiposProductos_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_TiposProductos_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                    " SELECT distinct " +
                        nameof(INTERNO_MantenimientoSimple_Modelo.id) + " = " + nameof(MAE_TiposProductos.id) + "," +
                        nameof(INTERNO_MantenimientoSimple_Modelo.codigo) + " = " + nameof(MAE_TiposProductos.codigo) + "," +
                        nameof(INTERNO_MantenimientoSimple_Modelo.descripcion) + " = " + nameof(MAE_TiposProductos.descripcion) + "," +
                        nameof(INTERNO_MantenimientoSimple_Modelo.fechaBorrado) + " = " + nameof(MAE_TiposProductos.fechaBorrado) +
                " FROM " + nameof(MAE_TiposProductos) +
                " WHERE " + nameof(MAE_TiposProductos.fechaBorrado) + " IS null AND " +
                            nameof(MAE_TiposProductos.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoSimple_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion
        
        #region MODELOS

        #region Modelo Simple
        private MAE_TiposProductos g_mdl_MAE_TiposProductos = null;
        public MAE_TiposProductos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(MAE_TiposProductos) + "." + nameof(MAE_TiposProductos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_TiposProductos;
        }
        public MAE_TiposProductos Obtener_Modelo_Por_IdUbicacionPerfil(long _lng_idUbicacionPerfil)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                " INNER JOIN " + nameof(MAE_UbicacionesPerfiles) + " ON " + nameof(MAE_UbicacionesPerfiles) + "." + nameof(MAE_UbicacionesPerfiles.idTipoProducto) + "=" + nameof(MAE_TiposProductos) + "." + nameof(MAE_TiposProductos.id) +
                                  //WHERE
                                  " WHERE " + nameof(MAE_UbicacionesPerfiles) + "." + nameof(MAE_UbicacionesPerfiles.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_idUbicacionPerfil)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Obtener_Modelo_Por_IdUbicacionPerfil), true);
            }

            return g_mdl_MAE_TiposProductos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MAE_TiposProductos = obj_Exferia_Entities.Database.SqlQuery<MAE_TiposProductos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MAE_TiposProductos) + "." + nameof(MAE_TiposProductos.id) + " , " +
                    nameof(MAE_TiposProductos) + "." + nameof(MAE_TiposProductos.codigo) + " , " +
                    nameof(MAE_TiposProductos) + "." + nameof(MAE_TiposProductos.descripcion) + " , " +
                    nameof(MAE_TiposProductos) + "." + nameof(MAE_TiposProductos.fechaBorrado) +
                " FROM " + nameof(MAE_TiposProductos);
        }

        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoSimple_Modelo mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar = (INTERNO_MantenimientoSimple_Modelo)_mdl_obj;
                MAE_TiposProductos mdl_MAE_TiposProductos_DatosViejos = new MAE_TiposProductos();

                // Ver si existe ######################################################################
                MAE_TiposProductos mdl_MAE_TiposProductos_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_MAE_TiposProductos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_TiposProductos_Final, mdl_MAE_TiposProductos_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_MAE_TiposProductos_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_TiposProductos) +
                                            " SET " +
                                                nameof(MAE_TiposProductos.codigo) + "=@codigo," +
                                                nameof(MAE_TiposProductos.descripcion) + "=@descripcion," +
                                                nameof(MAE_TiposProductos.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_TiposProductos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                         mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_TiposProductos_Final = new MAE_TiposProductos();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_MAE_TiposProductos_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_TiposProductos) +
                                                " (" +
                                                        nameof(MAE_TiposProductos.codigo) + "," +
                                                        nameof(MAE_TiposProductos.descripcion) + "," +
                                                        nameof(MAE_TiposProductos.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(MAE_TiposProductos.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@codigo," +
                                                    "@descripcion," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_TiposProductos), mdl_MAE_TiposProductos_DatosViejos, mdl_MAE_TiposProductos_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_ValorDevuelto_Modelo;
        }

        private void Cargar_DatosModelo(MAE_TiposProductos _mdl_MAE_TiposProductos, INTERNO_MantenimientoSimple_Modelo _mdl_INTERNO_MantenimientoSimple_Modelo)
        {
            _mdl_MAE_TiposProductos.id = _mdl_INTERNO_MantenimientoSimple_Modelo.id;
            _mdl_MAE_TiposProductos.codigo = _mdl_INTERNO_MantenimientoSimple_Modelo.codigo;
            _mdl_MAE_TiposProductos.descripcion = _mdl_INTERNO_MantenimientoSimple_Modelo.descripcion;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_TiposProductos mdl_MAE_TiposProductos_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MAE_TiposProductos_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_TiposProductos) +
                                                " SET " +
                                                nameof(MAE_TiposProductos.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_TiposProductos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_TiposProductos), null, mdl_MAE_TiposProductos_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposProductos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
